;msdos.asm



ReadSector:

;---------------------------
       mov      bx,[.vector]
       jmp      bx

.start1:
       call     SetPosRW
       mov      bx,.start2
       mov      [.vector],word bx
       ret

.start2:
;---------------------------

       mov      bx,.start1
       mov      [.vector],word bx

       mov      dx,word .diskName
       mov      ax,3D00h
       mov      al,2
       int      21h
       jc       ErrDisk

       mov      [.h],ax

       mov      dx,word [.pos]
       mov      cx,word [.posH]
       mov      bx,[.h]
       mov      ah,42h
       mov      al,1
       int      21h
       jc       ErrDiskLSEEK


       mov      bx,word [.h]
       mov      ax,3F00h
       mov      cx,0x04
       mov      dx,.buf ;%%%%%%%
       int      21h
       jc       ErrDisk


;close file
       mov      ah,3eh
       mov      bx,[.h]
       int      21h ;close file (dos service)


       mov      eax,dword [.buf]

       ret

.diskName db 'v56disk.bin',0
.h dw 0
.buf dd 0
.pos dw 0
.posH dw 0
.vector dw .start1


;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


WriteSector:

;---------------------------
       mov      bx,[.vector]
       jmp      bx

.start1:
       call     SetPosRW
       mov      bx,.start2
       mov      [.vector],word bx
       ret

.start2:
;---------------------------

       mov      [.buf],dword eax

       mov      bx,.start1
       mov      [.vector],word bx


       mov      dx,word .diskName
       mov      ax,3D00h
       mov      al,2
       int      21h
       jc       ErrDisk

       mov      [.h],ax


       mov      dx,word [.pos]
       mov      cx,word [.posH]
       mov      bx,[.h]
       mov      ah,42h
       mov      al,1
       int      21h
       jc       ErrDiskLSEEK


       mov      bx,[.h]
       mov      cx,4
       mov      ah,40h
       mov      dx,.buf
       int      21h
       jc       ErrDisk

;close file
       mov      ah,3eh
       mov      bx,[.h]
       int      21h ;close file (dos service)


       ret


.diskName db 'v56disk.bin',0
.h dw 0
.buf dd 0
.pos dw 0
.posH dw 0
.vector dw .start1


;((((((((((((((((((((((((((((((((((((


ErrDisk:
       mov      eax,dword [.ErrCod]
       ret
.ErrCod dd 'D001'


ErrDiskLSEEK:
       mov      eax,dword [.ErrCod]
       ret
.ErrCod dd 'D002'


GetPosRW:
       mov      ax,word [ReadSector.posH]
       shl      eax,16
       mov      ax,word [ReadSector.pos]
       shr      eax,2 ;/4
       ret

SetPosRW:
       shl      eax,2 ;*4
       mov      [ReadSector.pos],word ax
       mov      [WriteSector.pos],word ax
       shr      eax,16
       mov      [ReadSector.posH],word ax
       mov      [WriteSector.posH],word ax
       ret


;EOF

