;putchar.asm


PutCharTextMode:
       mov      ebx,dword [Screen.fText]
       cmp      ebx,0
       jz       .error

;---------------------------
       mov      bx,word [.vector]
       jmp      bx

.start:
       mov      [Pixel.Pos],dword eax
       mov      bx,.put
       mov      [.vector],word bx
       ret

.error:
       ret

.put:
       mov      bx,.start
       mov      [.vector],word bx

       shl      eax,24
       shr      eax,24
;al=char
       mov      [Pixel.Color],dword eax
       mov      [.CodChar],byte al ;<<<<<<<<<

       mov      eax,dword [Pixel.Pos]
       cmp      eax,dword [Screen.Size]
       ja       .posErr

       mov      ebx,dword [Screen.xMax]
       mov      ecx,dword [Screen.yMax]

       xor      edx,edx
.l1:
       cmp      eax,ebx
       jb       .l2
       sub      eax,ebx
       inc      edx
       dec      ecx
       jnz      .l1

.l2:
       mov      [.yChar],byte dl ;<<<<<<<
       mov      [.xChar],byte al ;<<<<<<<

       xor      bx,bx

       mov      dh,[.yChar]
       mov      dl,[.xChar]
       mov      ah,02h
       int      10h

       mov      ah,0ah
       xor      bh,bh
       mov      cx,1
       mov      al,[.CodChar]
       int      10h
       ret
.posErr:
       ret


.yChar db 0
.xChar db 0
.CodChar db 0
.vector dw .start


;EOF

