;vm56.asm

;⠭- 쭠  ᥩ  "⠭ ०"
;       SET_MODE = 0xf000


       include  'inc\beep.asm';macro


       org      100h
       use16


 mov si,word TableMode0109
;       mov      si,word TableMode0101
; mov si,word TableMode03


       call     InitVideo ;'inc\video\init.asm'

       call     GetCod
       call     vm56

       mov      si,word TableMode03
       call     InitVideo


       ret


       include  'inc\file.asm'

       include  'inc\video\video.asm'
       include  'inc\video\init.asm'
       include  'inc\video\data.asm'
       include  'inc\video\putchar.asm'
       include  'inc\video\putpix.asm'

       include  'inc\kbd\bios.asm'

       include  'inc\disk\msdos.asm'


GetCod:
       call     GetFile
       mov      si,Cod
       ret



vm56:
       mov      ax,si
       mov      [.ip],word ax
       mov      [.base],word ax
       mov      [.base0],word ax


.main:
       mov      si,word [vm56.ip]
       mov      eax, dword [si]

       cmp      eax,dword 99 ;#99 = test error stop point
       jz       .error


       add      si,word 4
       mov      [vm56.ip], word si
;eax = instruction
       shl      eax,1
       xor      ebx,ebx
       mov      bx ,word vm56.fun
       add      ebx,eax
       mov      ax,word [bx]
       mov      bx,ax
       call     bx

       jmp      .main

.error:
       pop      ax

       mov      al,'#'
       mov      ah,0eh
       mov      cx,1
       int      10h
       mov      al,'9'
       mov      ah,0eh
       mov      cx,1
       int      10h
       mov      al,'9'
       mov      ah,0eh
       mov      cx,1
       int      10h


;bios get key
       mov      ah,0
       int      16h
       ret      ;exit dos



.ip dw 0 ;x86- ᫥饩 樨
.base dw 0
.base0 dw 0

.fun:
dw .nop
dw .stop
dw .beep
dw .putMemConst ;#3
dw .put_Mem_Const ;#4
dw .putMemMem ;#5
dw .put_Mem_Mem ;#6
dw .jmpLabel ;#7 (size 2 dword) ;jmp label
dw .jmpMem ;#8 (size 2 dword) ;jmp mem
dw .jmpLabelIfMemZ ;#9 (size 3 dword) jmp label if mem = 0
dw .jmpLabelIfMemNZ ;#10 (size 3 dword) jmp label if mem =/= 0
dw .jmpLabelIf_Mem_Z ;#11 (size 3 dword) jmp label if [mem] = 0
dw .jmpLabelIf_Mem_NZ ;#12 (size 3 dword) jmp label if [mem] =/= 0
dw .jmpLabelIfMemAConst ;#13 (size 4 dword) jmp label if mem > const
dw .jmpLabelIfMemAEConst ;#14 (size 4 dword) jmp label if mem >= const
dw .jmpLabelIfMemBConst ;#15 (size 4 dword) jmp label if mem < const
dw .jmpLabelIfMemBEConst ;#16 (size 4 dword) jmp label if mem <= const
dw .jmpLabelIfMemEConst ;#17 (size 4 dword) jmp label if mem = const
dw .jmpLabelIfMemNEConst ;#18 (size 4 dword) jmp label if mem =/= const
dw .jmpLabelIf_Mem_AConst ;#19 (size 4 dword) jmp label if [mem] > const
dw .jmpLabelIf_Mem_AEConst ;#20 (size 4 dword) jmp label if [mem] >= const
dw .jmpLabelIf_Mem_BConst ;#21 (size 4 dword) jmp label if [mem] < const
dw .jmpLabelIf_Mem_BEConst ;#22 (size 4 dword) jmp label if [mem] <= const
dw .jmpLabelIf_Mem_EConst ;#23 (size 4 dword) jmp label if [mem] = const
dw .jmpLabelIf_Mem_NEConst ;#24 (size 4 dword) jmp label if [mem] =/= const
dw .jmpLabelIfMemAMem ;#25 (size 4 dword) jmp label if mem > mem
dw .jmpLabelIfMemAEMem ;#26 (size 4 dword) jmp label if mem >= mem
dw .jmpLabelIfMemBMem ;#27 (size 4 dword) jmp label if mem < mem
dw .jmpLabelIfMemBEMem ;#28 (size 4 dword) jmp label if mem <= mem
dw .jmpLabelIfMemEMem ;#29 (size 4 dword) jmp label if mem = mem
dw .jmpLabelIfMemNEMem ;#30 (size 4 dword) jmp label if mem =/= mem

dw .reserved ;#31
dw .reserved
dw .reserved
dw .reserved
dw .reserved
dw .reserved ;#36 .  \/

;dw .jmpLabelIf_Mem_AMem ;#31 (size 4 dword) jmp label if [mem] > mem
;dw .jmpLabelIf_Mem_AEMem ;#32 (size 4 dword) jmp label if [mem] >= mem
;dw .jmpLabelIf_Mem_BMem ;#33 (size 4 dword) jmp label if [mem] < mem
;dw .jmpLabelIf_Mem_BEMem ;#34 (size 4 dword) jmp label if [mem] <= mem
;dw .jmpLabelIf_Mem_EMem ;#35 (size 4 dword) jmp label if [mem] = mem
;dw .jmpLabelIf_Mem_NEMem ;#36 (size 4 dword) jmp label if [mem] =/= mem

dw .incMem ;#37 (size 2 dword) inc mem (mem+1)
dw .inc_Mem_ ;#38 (size 2 dword) inc [mem] ([mem]+1)
dw .decMem ;#39 (size 2 dword) dec mem (mem-1)
dw .dec_Mem_ ;#40 (size 2 dword) dec [mem] ([mem]-1)
dw .addMemConst ;#41 (size 3 dword) add mem,const (mem+const)
dw .add_Mem_Const ;#42 (size 3 dword) add [mem],const ([mem]+n)
dw .subMemConst ;#43 (size 3 dword) sub mem ,const ( mem -n)
dw .sub_Mem_Const ;#44 (size 3 dword) sub [mem],const ([mem]-n)

;dw .reserved ;#45-48
dw .addMemMem ;#45 (size 3 dword) add mem,mem

dw .reserved ;#45-48
dw .reserved ;#45-48
dw .reserved ;#45-48

;;dw .addMemMem ;#45 (size 3 dword) add mem,mem
;dw .add_Mem_Mem ;#46 (size 3 dword) add [mem],mem
;dw .subMemMem ;#47 (size 3 dword) sub mem ,mem
;dw .sub_Mem_Mem ;#48 (size 3 dword) sub [mem],mem


dw .putPortConst ;#49 (size 3 dword) const>port
dw .putPortMem ;#50 (size 3 dword) mem>port
dw .getPortMem ;#51 (size 3 dword) get port mem (out port,mem) port>mem


dw .callLabelMem ;#52 (size 3 dword)
dw .shrMemConst ;#53 (size 3 dword)
dw .shlMemConst ;#54 (size 3 dword)

dw .putMem_Mem_  ;#55 (3 dword)

dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76

dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76

dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76

dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76
dw .reserved ;#56-76

dw .reserved ;#56-76

dw .newBaseConstLabel ;#77 (size 3 dword)



.ports: ;data&control ports table
dw .reserved ;#0

dw Port_01_DISPLAYd
dw Port_02_DISPLAYc

dw Port_03_KBDd
dw Port_04_KBDc

dw Port_05_DISKd
dw Port_06_DISKc



;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++=

.reserved:
       ret


;----------
.nop: ;#0
       ret

;----------
.stop: ;#1
       pop      ax
       ret

;----------
.beep: ;#2
       pusha
       call     .beepM
       popa
       ret

;----------
.putMemConst: ;#3   祩 () ᫮
       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax ;ebx saved!
       call     GetArg2 ;頥 eax = const (arg2) - (!di not killed)

;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2

;----------
.put_Mem_Const: ;#4   祩 () ᫮ /!ᢥ!/
       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax

;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
;eax =  祩 㤠  ⠭
       mov      ebx,eax ;࠭塞  ᯮ㥬 ॣ
       call     GetArg2 ;eax = const (arg2)
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------

.putMemMem: ;#5   祩 () ᫮   אַ

       call     GetArg2 ;eax = memory adress (arg2)
       mov      ebx,eax

;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
       mov      edx,eax ;save eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx

;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2

;----------

.put_Mem_Mem: ;#6   祩 () ᫮   /!ᢥ!/
       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax

;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
;eax =  祩 㤠  ⠭

       mov      edx,eax ;push eax ⥯ edx =      arg1

       call     GetArg2 ;eax = memory2 (arg2)
       mov      ebx,eax

;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
       mov      ebx,edx

;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2

;----------
.jmpLabel: ;#7 (size 2 dword)
       call     GetArg1 ;eax = memory adress (arg1)
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpMem: ;#8
       call     GetArg1 ;eax = label (memory adress - arg1)
       mov      ebx,eax
;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIfMemZ: ;#9 (size 3 dword)
; jmp on label if value in mem = 0
; 室   ᫨ 祭  㪠 祩 ࠢ 

       call     GetArg2 ;eax = point of const (arg2)
       mov      ebx,eax

;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword

       cmp      eax,0
       jnz      RetVm56Cod2 ;襭 樨 vm56 ip+2


       call     GetArg1 ;eax = target memory adress (arg1)
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------

.jmpLabelIfMemNZ: ;#10 (size 3 dword) jmp if mem =/= 0
       call     GetArg2 ;eax = point of value (arg2)
;eax = 祩   ன 祭 (arg2)
       mov      ebx,eax

;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
; eax = value (arg2)
       cmp      eax,0
       jz       RetVm56Cod2 ;襭 樨 vm56 ip+2

       call     GetArg1 ;eax = target memory adres for jmp (arg1)
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!


;----------

.jmpLabelIf_Mem_Z: ;#11 (size 3 dword) jmp [mem] if mem = 0

       call     GetArg2 ;eax = memory adress (arg2)
; eax - 祩   ன value (arg2)
       mov      ebx,eax
;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
; eax - value (arg2)
       cmp      eax,0
       jnz      RetVm56Cod2 ;襭 樨 vm56 ip+2

       call     GetArg1 ;eax = [memory] adress (arg1)
       mov      ebx,eax
       call     GetCodDword
; eax - target memory (arg1)
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIf_Mem_NZ: ;#12 (size 3 dword) jmp if [mem] =/= 0

       call     GetArg2 ;eax = memory adress (arg2)
; eax - 祩   ன value (arg2)
       mov      ebx,eax
;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
; eax - value (arg2)

       cmp      eax,0
       jz       RetVm56Cod2 ;襭 樨 vm56 ip+2

       call     GetArg1 ;eax = [memory] adress (arg1)
       mov      ebx,eax
       call     GetCodDword
; eax - target memory (arg1)
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIfMemAConst: ;#13 (size 4 dword) jmp label if mem > const
;室 ᫨ ᮤন 祩  |ன ࠭| 
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpMemAConst mem,mem1,const

       call     GetArg2 ;eax = mem1 (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)
       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jbe      RetVm56Cod3 ;襭 樨 vm56 ip+3

       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------

.jmpLabelIfMemAEConst: ;#14 (size 4 dword) jmp label if mem >= const
;室 ᫨ ᮤন 祩  |ன ࠭|   ࠢ
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpMemAEConst mem,mem1,const

       call     GetArg2 ;eax = mem1 (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)
       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jb       RetVm56Cod3 ;襭 樨 vm56 ip+3

       call     GetArg1
       jmp      JmpVm56Cod ;jmp eax = mem (arg1)

;----------

.jmpLabelIfMemBConst: ;#15 (size 4 dword) jmp label if mem < const
;室 ᫨ ᮤন 祩  |ன ࠭| 
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpMemBConst mem,mem1,const

       call     GetArg2 ;eax = mem1 (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)
       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jae      RetVm56Cod3 ;襭 樨 vm56 ip+3

       call     GetArg1
       jmp      JmpVm56Cod ;jmp eax = mem (arg1)

;----------
.jmpLabelIfMemBEConst: ;#16 (size 4 dword) jmp label if mem <= const
;室 ᫨ ᮤন 祩  |ன ࠭|   ࠢ
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpMemBEConst mem,mem1,const

       call     GetArg2 ;eax = mem1 (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)
       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       ja       RetVm56Cod3 ;襭 樨 vm56 ip+3
       call     GetArg1
       jmp      JmpVm56Cod ;jmp eax = mem (arg1)

;----------
.jmpLabelIfMemEConst: ;#17 (size 4 dword) jmp label if mem = const
;室 ᫨ ᮤন 祩  |ன ࠭| ࠢ
;⠭e |⨩ ࠭|


       call     GetArg2 ;eax = mem1 (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)
       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jnz      RetVm56Cod3 ;襭 樨 vm56 ip+3

       call     GetArg1
       jmp      JmpVm56Cod ;jmp eax = mem (arg1)

;---------

.jmpLabelIfMemNEConst: ;#18 (size 4 dword) jmp label if mem =/= const
;室 ᫨ ᮤন 祩  |ன ࠭|  ࠢ
;⠭e |⨩ ࠭|
;ᨭ⠪ jmpMemNEConst mem,mem1,const


       call     GetArg2 ;eax = mem1 (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)
       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jz       RetVm56Cod3 ;襭 樨 vm56 ip+3
       call     GetArg1
       jmp      JmpVm56Cod ;jmp eax = mem (arg1)

;---------
.jmpLabelIf_Mem_AConst: ;#19 (size 4 dword) jmp label if [mem] > const
;- ᢥ 
;室 ᫨ ᮤন [祩 ] |ன ࠭| 
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpLabelIf_Mem_AConst label,[mem1],const


       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - memory point on value (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)

       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jbe      RetVm56Cod3 ;襭 樨 vm56 ip+3
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIf_Mem_AEConst: ;#20 (size 4 dword) jmp label if [mem] >= const
;- ᢥ 
;室 ᫨ ᮤন [祩 ] |ன ࠭|   ࠢ
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpLabelIf_Mem_AEConst label,[mem1],const

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - memory point on value (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)
       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jb       RetVm56Cod3 ;襭 樨 vm56 ip+3
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------

.jmpLabelIf_Mem_BConst: ;#21 (size 4 dword) jmp label if [mem] < const
;- ᢥ 
;室 ᫨ ᮤন [祩 ] |ன ࠭| 
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpLabelIf_Mem_BConst label,[mem1],const

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - memory point on value (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)

       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jae      RetVm56Cod3 ;襭 樨 vm56 ip+3
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------

.jmpLabelIf_Mem_BEConst: ;#22 (size 4 dword) jmp label if [mem] <= const
;- ᢥ 
;室 ᫨ ᮤন [祩 ] |ன ࠭|   ࠢ
;祬 ⠭ |⨩ ࠭|
;ᨭ⠪ jmpLabelIf_Mem_BEConst label,[mem1],const

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - memory point on value (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)

       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       ja       RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------


.jmpLabelIf_Mem_EConst: ;#23 (size 4 dword) jmp label if [mem] = const
;- ᢥ 
;室 ᫨ ᮤন [祩 ] |ன ࠭| ࠢ
; ⠭ |⨩ ࠭|
;ᨭ⠪ jmpLabelIf_Mem_EConst label,[mem1],const

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - memory point on value (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)

       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jnz      RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------

.jmpLabelIf_Mem_NEConst: ;#24 (size 4 dword) jmp label if [mem] =/= const
;- ᢥ 
;室 ᫨ ᮤন [祩 ] |ன ࠭|  ࠢ
; ⠭ |⨩ ࠭|
;ᨭ⠪ jmpLabelIf_Mem_NEConst label,[mem1],const

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - memory point on value (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value (arg2)

       mov      edx,eax
       call     GetArg3
       cmp      edx, eax ;eax = const (arg3)
       jz       RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------

.jmpLabelIfMemAMem: ;#25 (size 4 dword) jmp label if mem > mem
;室 ᫨ ᮤন [祩 ] |ன ࠭|  祬
;ᮤন [祩 ] |⨩ ࠭|
;ᨭ⠪ jmpLabelIfMemAMem label,mem1,mem2

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value mem1 (arg2)
       mov      edx,eax ; << edx ᯮ  ६ ࠭!

       call     GetArg3
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       cmp      edx, eax ;eax = mem2 (arg3)
       jbe      RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIfMemAEMem: ;#26 (size 4 dword) jmp label if mem >= mem
;室 ᫨ ᮤন [祩 ] |ன ࠭|   ࠢ 祬
;ᮤন [祩 ] |⨩ ࠭|
;ᨭ⠪ jmpLabelIfMemAEMem label,mem1,mem2

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value mem1 (arg2)
       mov      edx,eax ; << edx ᯮ  ६ ࠭!

       call     GetArg3
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       cmp      edx, eax ;eax = mem2 (arg3)
       jb       RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIfMemBMem: ;#27 (size 4 dword) jmp label if mem < mem
;室 ᫨ ᮤন [祩 ] |ன ࠭|  祬
;ᮤন [祩 ] |⨩ ࠭|
;ᨭ⠪ jmpLabelIfMemBMem label,mem1,mem2

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value mem1 (arg2)
       mov      edx,eax ; << edx ᯮ  ६ ࠭!

       call     GetArg3
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       cmp      edx, eax ;eax = mem2 (arg3)
       jae      RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIfMemBEMem: ;#28 (size 4 dword) jmp label if mem <= mem
;室 ᫨ ᮤন [祩 ] |ன ࠭|   ࠢ 祬
;ᮤন [祩 ] |⨩ ࠭|
;ᨭ⠪ jmpLabelIfMemBEMem label,mem1,mem2

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value mem1 (arg2)
       mov      edx,eax ; << edx ᯮ  ६ ࠭!

       call     GetArg3
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       cmp      edx, eax ;eax = mem2 (arg3)
       ja       RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIfMemEMem: ;#29 (size 4 dword) jmp label if mem = mem
;室 ᫨ ᮤন [祩 ] |ன ࠭| ࠢ
;ᮤন [祩 ] |⨩ ࠭|
;ᨭ⠪ jmpLabelIfMemEMem label,mem1,mem2

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value mem1 (arg2)
       mov      edx,eax ; << edx ᯮ  ६ ࠭!

       call     GetArg3
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       cmp      edx, eax ;eax = mem2 (arg3)
       jnz      RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------
.jmpLabelIfMemNEMem: ;#30 (size 4 dword) jmp label if mem =/= mem
;室 ᫨ ᮤন [祩 ] |ன ࠭|  ࠢ
;ᮤন [祩 ] |⨩ ࠭|
;ᨭ⠪ jmpLabelIfMemNEMem label,mem1,mem2

       call     GetArg2 ;eax = [mem1] (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
; eax - value mem1 (arg2)
       mov      edx,eax ; << edx ᯮ  ६ ࠭!

       call     GetArg3
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       cmp      edx, eax ;eax = mem2 (arg3)
       jz       RetVm56Cod3 ;襭 樨 vm56 ip+3 <<ࠢ !
       call     GetArg1
       jmp      JmpVm56Cod ;eax = adres ------- !JMP!

;----------


;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++RESERVED31-36

;䬥⨪
;----------
.incMem: ;#37 (size 2 dword) inc mem (mem+1)

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       inc      eax
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod1 ;襭 樨 vm56 ip+1

;----------
.inc_Mem_: ;#38 (size 2 dword) inc [mem] ([mem]+1)
       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax

;᭠砫  ॠ 
       call     GetCodDword

;⥯ 祭 祩
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       inc      eax
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
;  ॠ 
       call     GetCodDword
       mov      ebx,eax
       mov      eax,edx ; edx 뫮 ࠭  祭

;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod1 ;襭 樨 vm56 ip+1

;----------

.decMem: ;#39 (size 2 dword) dec mem (mem-1)
       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       dec      eax
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod1 ;襭 樨 vm56 ip+1

;----------
.dec_Mem_: ;#40 (size 2 dword) dec [mem] ([mem]-1)

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax

;᭠砫  ॠ 
       call     GetCodDword

;⥯ 祭 祩
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

       dec      eax
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
;  ॠ 
       call     GetCodDword
       mov      ebx,eax
       mov      eax,edx ; edx 뫮 ࠭  祭

;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod1 ;襭 樨 vm56 ip+1

;----------
.addMemConst: ;#41 (size 3 dword) add mem,n (mem+n)
       call     GetArg2 ;eax = const (arg2)
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       add      eax,edx ; edx -  ᫮  㢥祭 - const
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------

.add_Mem_Const: ;#42 (size 3 dword) add [mem],const ([mem]+n)

       call     GetArg2 ;eax = const (arg2)
       mov      edx,eax

       call     GetArg1 ;eax = ᢥ memory adress (arg1)
       mov      ebx,eax
;⥯  ॠ 
       call     GetCodDword
;⥯ 祭 祩
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       add      eax,edx ; edx -  ᫮  㢥祭 - const
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
;⥯  ॠ 
       call     GetCodDword
       mov      ebx,eax

       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------


.subMemConst: ;#43 (size 3 dword) sub mem ,const ( mem -n)

       call     GetArg2 ;eax = const (arg2)
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       sub      eax,edx ; edx -  ᫮  㢥祭 - const
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------


;----------
.sub_Mem_Const: ;#44 (size 3 dword) sub [mem],const ([mem]-n)
       call     GetArg2 ;eax = const (arg2)
       mov      edx,eax

       call     GetArg1 ;eax = ᢥ memory adress (arg1)
       mov      ebx,eax
;⥯  ॠ 
       call     GetCodDword
;⥯ 祭 祩
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       sub      eax,edx ; edx -  ᫮  㢥祭 - const
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
;⥯  ॠ 
       call     GetCodDword
       mov      ebx,eax

       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------

.addMemMem: ;#45 (size 3 dword) add mem,mem
       call     GetArg2 ;eax = mem2 (arg2)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       mov      edx,eax


       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭
       add      eax,edx ; edx -  ᫮  㢥祭 - const
       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------





;_____________________________________________________________________________XX
;-뢮 ॠ   ⮢

.putPortConst: ;#49 (size 3 dword) const>port (in port,const)

       call     GetArg1 ;(arg1)

       shl      eax,1
       xor      ebx,ebx
       mov      bx ,word vm56.ports
       add      ebx,eax
       mov      ax,word [bx]
       push     ax
       call     GetArg2 ;(arg1)
;eax = 祭  
       pop      bx
       call     bx

       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2

.putPortMem: ;#50 (size 3 dword) mem>port

       call     GetArg1 ;(arg1)

       shl      eax,1
       xor      ebx,ebx
       mov      bx ,word vm56.ports
       add      ebx,eax
       mov      ax,word [bx]
       push     ax

;-  ॠ 
       call     GetArg2 ;(arg2)
       mov      ebx,eax
;- ⥯  祭
       call     GetCodDword
;- ⥯ eax = 祭  

       pop      bx
       call     bx

       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2


;----------
.getPortMem: ;#50 (size 3 dword) get port mem (out port,mem) port>mem
       call     GetArg1 ;(arg1)

       shl      eax,1
       xor      ebx,ebx
       mov      bx ,word vm56.ports
       add      ebx,eax
       mov      ax,word [bx]
       mov      bx,ax
       call     bx

       mov      edx,eax

       call     GetArg2 ;(arg2)
       mov      ebx,eax ;ebx =    祭  ணࠬ
       mov      eax,edx ; eax = 祭  
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword

       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2




;---------

.callLabelMem: ;#52 (size 3 dword)

       call     GetArg2 ;eax = mem (arg2)
       mov      ebx,eax

       call     GetIP56 ;eax = ip
       add      eax,2

       call     PutCodDword

       call     GetArg1
       jmp      JmpVm56Cod ;jmp eax = mem (arg1)

;---------

.shrMemConst: ;#53 (size 3 dword)
       call     GetArg2 ;eax = const (arg2)
       cmp      eax,0
       jz       RetVm56Cod2 ;襭 樨 vm56 ip+2
       cmp      eax,31
       ja       RetVm56Cod2 ;襭 樨 vm56 ip+2

       mov      edx,eax



       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭

.R_shift:
       shr      eax,1 ; edx -  ᫮  ᤢ - const
       dec      edx
       jnz      .R_shift

       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------

.shlMemConst: ;#54 (size 3 dword)
       call     GetArg2 ;eax = const (arg2)

       cmp      eax,0
       jz       RetVm56Cod2 ;襭 樨 vm56 ip+2
       cmp      eax,31
       ja       RetVm56Cod2 ;襭 樨 vm56 ip+2

       mov      edx,eax



       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
call GetCodDword ;室: ebx =  祩,室 eax = 祭


.L_shift:
       shl      eax,1 ; edx -  ᫮  ᤢ - const
       dec      edx
       jnz      .L_shift

       mov      edx,eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx
;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2
;----------

 .putMem_Mem_:  ;#55 (3 dword)
        call     GetArg2 ;eax = [memory adress] (arg2)
        mov      ebx,eax
;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
;eax = ⥯ אַ 
       mov      ebx,eax
;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
       call     GetCodDword
       mov      edx,eax ;save eax

       call     GetArg1 ;eax = memory adress (arg1)
       mov      ebx,eax
       mov      eax,edx

;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
       call     PutCodDword
       jmp      RetVm56Cod2 ;襭 樨 vm56 ip+2

;----------


.newBaseConstLabel: ;#77 (size 3 dword)

xor ebx,ebx
       mov     bx,word [vm56.base0] ;⨭ 祭
;       mov     bx,word [vm56.base]
;sub ax,bx

       call     GetArg1 ;eax = const (arg1)
;eax -  ७ -ᬥ饭  ண 56
shl eax,2
add eax,ebx


       mov      [vm56.base],word ax ;  56  ⥫ ண-x86 (⭮⥫)

       call     GetArg2 ;eax = label (arg2)

jmp JmpVm56Cod ;eax = adres
;       shl      eax,2 ;* 4
;       add      ax,word [vm56.base];Cod ;start cod for virtual mashine
;       mov      [vm56.ip], word ax
;       ret



.beepM:
       beep
       ret


;%%%%%%%%%%%%%%%%% [ ணࠬ  ࠡ   ] %%%%%%%%%%%%%%%%%%%%%%%

;頥  eax ⥪騩_+1  믮塞    㠫쭮
;設
GetIP56:
       xor      eax,eax ;⪠  16 
       mov      ax,word [vm56.ip] ; x86 
       sub      ax,word [vm56.base];Cod ;start cod for virtual mashine
       shr      eax,2 ;/4 -  vm56 
       ret


GetArg1:
       mov      si,word [vm56.ip]
       mov      eax, dword [si];memory
       ret

GetArg2:
       mov      si,word [vm56.ip]
       mov      eax, dword [si+4];memory
       ret

GetArg3:
       mov      si,word [vm56.ip]
       mov      eax, dword [si+8];memory
       ret


AddVm56Ip:
;correct ip for size istrucrion eax = size (arg`s)
       shl      eax,2 ;*4
       mov      bx,word [vm56.ip]
       add      ax,bx
       mov      [vm56.ip],word ax
       ret

;頥 祭  ᭮ ࠭⢮ vm56-ணࠬ (ebx = mem,eax = val)
PutCodDword:
       shl      ebx,2 ;* 4
       add      bx,word [vm56.base];Cod ;start cod for virtual mashine
       mov      [bx],dword eax
       ret

;Get 祭 from vm56-ணࠬ (ebx = mem,eax = val)
GetCodDword:
       shl      ebx,2 ;* 4
       add      bx,word [vm56.base];Cod ;start cod for virtual mashine
       mov      eax,dword [bx]
       ret


JmpVm56Cod: ;eax = adres
       shl      eax,2 ;* 4
       add      ax,word [vm56.base];Cod ;start cod for virtual mashine
       mov      [vm56.ip], word ax
       ret




RetVm56Cod1:
       mov      eax,dword 1
       call     AddVm56Ip ;㢥稢 vm56.ip  dword 祭  eax
       ret

RetVm56Cod2:
       mov      eax, dword 2
       call     AddVm56Ip ;㢥稢 vm56.ip  dword 祭  eax
       ret


RetVm56Cod3:
       mov      eax, dword 3
       call     AddVm56Ip ;㢥稢 vm56.ip  dword 祭  eax
       ret




;|||||||||||||||||||||||||||||PORTS

       include  'inc\ports\disp.asm'
       include  'inc\ports\kbd.asm'
       include  'inc\ports\disk.asm'


;%%%%%%%%%%%%%%%%% [     ணࠬ vm56] %%%%%%%%%%%%%%%%%%%%%%%%

Cod:
rb 0x0fff ; 0x0fff = max size vm56-programs

rb 65535-$-2
       if       $ > 10000h
display 'warning: 64k limit exceeded.'
       end      if


;EOF


