;bios.asm

;GetKeyCod: eax = bios kbd scancode (al)
;GetKeyChar: eax = ASCII code (al)
;!eax - 稬 ⮫쪮 訨 8 


GetKeyCod:

       call     GetBiosKBD_Cod
       shl      eax,16
       shr      eax,24
       ret

GetKeyChar:

       call     GetBiosKBD_Cod
       shl      eax,24
       shr      eax,24
       ret


;GetBiosKBD_Cod - out: eax
;᫨ 뫮  -  ᥣ 
;᫨ 뫮 e -  㣮
; ⮣ ᫥騩 맮  -  ⮩ 

GetBiosKBD_Cod:
       mov      bx,[.vector]
       jmp      bx
.start:
       mov      ah,1 ;bios fun - "get key" set ZF ᫨  뫮 
       int      16h
       jz       .notPress

       mov      bx,.intKBD
       mov      [.vector],word bx
       mov      eax,dword 0x0cccccccc
       ret

.intKBD:

       mov      bx,.start
       mov      [.vector],word bx

       mov      ah,0 ;bios fun - "get key"
       int      16h
       ret

.notPress:
       mov      eax,dword 0xffffffff
       ret

.vector dw .start



;EOF

