;putpix.asm


PutPixel:
       mov      ebx,dword [Screen.fText]
       cmp      ebx,1
       jz       .error

;---------------------------
       mov      bx,[.vector]
       jmp      bx

.start:
       mov      [Pixel.Pos],dword eax
       mov      bx,.put
       mov      [.vector],word bx
       ret

.error:
       ret

.put:
       mov      bx,.start
       mov      [.vector],word bx

       mov      [Pixel.Color],dword eax
       mov      [.ColorPixel],byte al ;<<<<<<<<<

       mov      eax,dword [Pixel.Pos]
       cmp      eax,dword [Screen.Size]
       ja       .posErr

       mov      ebx,dword [Screen.xMax]
       mov      ecx,dword [Screen.yMax]

       xor      edx,edx
.l1:
       cmp      eax,ebx
       jb       .l2
       sub      eax,ebx
       inc      edx
       dec      ecx
       jnz      .l1

.l2:
       mov      [.yPixel],word dx ;<<<<<<<
       mov      [.xPixel],word ax ;<<<<<<<

       mov      ah,0ch
       xor      bh,bh
       mov      dx,[.yPixel]
       mov      cx,[.xPixel]
       mov      al,[.ColorPixel]
       int      10h
       ret

.posErr:
       ret


.yPixel dw 0
.xPixel dw 0
.ColorPixel db 0
.vector dw .start

;EOF



